#ifndef RECORDNODE_HPP__
#define RECORDNODE_HPP__
#include "nodes/base/base.hpp"
#include <opencv2/opencv.hpp>

namespace GNode
{

class RecordNode : public BaseNode
{
public:
    RecordNode() = delete;
    RecordNode(const std::string& name) : BaseNode(name, NODE_TYPE::DES_NODE) {}
    virtual ~RecordNode() 
    { 
        stop(); 
        if (writer_.isOpened())
        {
            writer_.release();
        }
    }

    void work() override;
    void set_record_path(const std::string& path) { record_path_ = path; }
    void set_fps(int fps) { fps_ = fps; }
    void set_fourcc(int fourcc) { fourcc_ = fourcc; }
private:
    std::string record_path_;
    int fps_ = 25;
    int fourcc_ = cv::VideoWriter::fourcc('X', '2', '6', '4');
    cv::VideoWriter writer_;
};
    
}
#endif // RECORDNODE_HPP__